﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GDIEngine
{
    
    /// <summary>
    /// Atlas List of sprited image file
    /// </summary>
    /// <typeparam name="T">Type of Texture Format</typeparam>
    public class Atlas<T> : IList<T>
    {
        public int MaxSize { get; set; }
        private Queue<T> Items = new Queue<T>();

        public int IndexOf(T item)
        {
            throw new NotImplementedException();
        }

        public void Insert(int index, T item)
        {
           
        }

        public void RemoveAt(int index)
        {
            Queue<T> retVal = new Queue<T>(Count - 1);

            for (Int32 i = 0; i < this.Count - 1; i++)
            {
                if (i != index)
                {
                    retVal.Enqueue(this.ElementAt(i));
                }
            }                    
        }

        public T this[int index]
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public void Add(T item)
        {
            Items.Enqueue(item);
            if (Items.Count == MaxSize)
            {
                Items.Dequeue();
            }
        }

        public void Clear()
        {
            Items.Clear();
        }

        public bool Contains(T item)
        {
            throw new NotImplementedException();
        }

        public void CopyTo(T[] array, int arrayIndex)
        {
            throw new NotImplementedException();
        }

        public int Count
        {
            get{ return Items.Count(); }
        }

        public bool IsReadOnly
        {
            get { throw new NotImplementedException(); }
        }

        public bool Remove(T item)
        {
            throw new NotImplementedException();
        }

        public IEnumerator<T> GetEnumerator()
        {
            throw new NotImplementedException();
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            throw new NotImplementedException();
        }
    }
     


    /// <summary>
    /// Asset Manager
    /// </summary>
    public class AssetManager
    {

        public List<Texture2D> TextureList = new List<Texture2D>();
        public List<TiledTexture> TiledList = new List<TiledTexture>();
        public List<AnimatedTexture> AnimatedList = new List<AnimatedTexture>();

        /// <summary>
        /// Load Resource from file
        /// </summary>
        /// <typeparam name="T">Resource Type</typeparam>
        /// <param name="file">string path</param>
        public void LoadFromFile<T>(string file)
        {
            Type tp = typeof(T);

            if (tp == typeof(Texture2D))
            {
                Texture2D tx = new Texture2D(file);
                TextureList.Add(tx);
            }


        }


        /// <summary>
        /// Load Tiled Texture
        /// </summary>
        /// <typeparam name="T">Type of Texture</typeparam>
        /// <param name="file">file path</param>
        /// <param name="HorizontalFrame">Horizontal Frame</param>
        /// <param name="vetricalFrame">Vertical Frame</param>
        public void LoadFromFile<T>(string file, int HorizontalFrame, int vetricalFrame)
        {
            Type tp = typeof(T);

       
            if (tp == typeof(TiledTexture))
            {
                TiledTexture tx = new TiledTexture(file, HorizontalFrame, vetricalFrame);
                TiledList.Add(tx);
            }

            if (tp == typeof(AnimatedTexture))
            {
                AnimatedTexture tx = new AnimatedTexture(file, HorizontalFrame, vetricalFrame);
                AnimatedList.Add(tx);
            }

        }


    

    }
}
